// This class contains dynamic info. It is necessary to save the information
// retrieved by the parser for the AccidentPlanner

// 	Name: DynamicInfo
//	Author: Arjan Egges
//	Version: 1.0

package  se.lth.cs.carsimgui;

class DynamicInfo {
   
   // Dynamic info consists of:
   public EventChain ceb;		// A (incomplete) eventchain
   public int startsignIndex;		// Index of the startpoint Roadsign
   public int endsignIndex;		// Index of the endpoint Roadsign
   public int initDirection;		// Initial direction of the vehicle
   public float startPoint;		// The startpoint of the vehicle
   public float endPoint;		// The endpoint of the vehicle
   
   // Constants
   public static final int NORTH = 0;
   public static final int SOUTH = 1;
   public static final int EAST = 2;
   public static final int UNKNOWN_DIRECTION = -1;
   public static final int WEST = 3;
   
   public DynamicInfo() {
      startsignIndex = -1;
      endsignIndex = -1;
      ceb = new EventChain();
      initDirection = UNKNOWN_DIRECTION;
      startPoint = 20.0f;
      endPoint = 20.0f;
   }
}