// Reads the filenames of a specified filetype out of the folder data/.

package  se.lth.cs.carsimgui;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Comparator;
import java.util.Arrays;
import java.text.Collator;

public class FileFilter implements FilenameFilter
{
	String filetype;
	File dir;
	
	public FileFilter ()
	{
		dir = new File ("carsimdata/.");
	}

	public boolean accept (File dir, String name)
	{
		return name.endsWith(filetype);
	}
	
	public String [] getFileArray(String ft)
	{
		filetype = ft;
		String [] resultfiles = dir.list(this);
		Arrays.sort(resultfiles, new StringArraySorter());
		
		for (int i=0;i<resultfiles.length;i++)
		{
			resultfiles[i] = resultfiles[i].substring(0,resultfiles[i].lastIndexOf('.'));
		}
		return resultfiles;
	}
	
	/*
	private class StringArraySorter extends Collator
	{
		public StringArraySorter()
		{
			super();
		}
		
		public int compare (Object string1, Object string2)
		{
			return super.compare(string1,string2);
		}
		
		public int hashCode()
		{
			return 0;
		}
		
		public int getCollationKey()
		{
		
		}
	}
	*/
	
	private class StringArraySorter implements Comparator
	{
		public StringArraySorter()
		{
		
		}
		
		public int compare (Object string1, Object string2)
		{
			int result = 0;
			try
			{
				result = ((String)string1).toLowerCase().compareTo(((String)string2).toLowerCase());
			}
			catch (Exception e)
			{
				System.out.println("Exception in FileFilter.StringArraySorter.compare(): "+e);
			}
			return result;
		}
		
		public boolean equals(Object obj)
		{
			return false;
		}
	}
}
