// This class generates the programs main window.
// It contains a menubar, textfields, buttons as well as the function calls 
// in the case of an event (pressing a button, selecting a menu item.

package  se.lth.cs.carsimgui;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.io.*;

public class MainWindow extends JFrame {
  
	MainWindow_Loading loading;
	
	public Font boldFont 			= new Font("Dialog", Font.BOLD, 12);
	public Font statusFont 			= new Font("Dialog", Font.PLAIN,10);
	public final Dimension hpad10 		= new Dimension(10,1);
	public final Dimension vpad10 		= new Dimension(1,10);
	public final Dimension square20		= new Dimension(20,27);
	public final static Insets insets0	= new Insets(0,0,0,0);
	public final static Insets insets3	= new Insets(3,3,3,3);
	public final Border emptyBorder10 	= new EmptyBorder(10,10,10,10);
	public final static Color bgColor 	= new Color(230,230,230);
	public final Color textareaColor 	= new Color(255,255,255);
	
	ImageIcon languageEnglishIcon		= new ImageIcon("img/language_english.gif");
	ImageIcon languageDeutschIcon		= new ImageIcon("img/language_deutsch.gif");
	ImageIcon languageEspanolIcon		= new ImageIcon("img/language_espanol.gif");
	ImageIcon languageFrancaisIcon		= new ImageIcon("img/language_francais.gif");
	ImageIcon languageSvenskaIcon		= new ImageIcon("img/language_svenska.gif");

	ImageIcon newButtonIcon			= new ImageIcon("img/new.gif");
	ImageIcon saveButtonIcon		= new ImageIcon("img/save.gif");
	ImageIcon parseButtonIcon		= new ImageIcon("img/parse.gif");
	ImageIcon validIcon			= new ImageIcon("img/xmldoc_valid.gif");
	ImageIcon invalidIcon			= new ImageIcon("img/xmldoc_invalid.gif");
	ImageIcon unparsedIcon			= new ImageIcon("img/parse.gif");

	ImageIcon generateXMLMenuIcon		= new ImageIcon("img/generateXML.gif");
	ImageIcon generateXMLIcon		= new ImageIcon("img/generateXML1.gif");
	ImageIcon generateXMLRolloverIcon	= new ImageIcon("img/generateXML2.gif");
	ImageIcon generateXMLPressedIcon	= new ImageIcon("img/generateXML3.gif");

	ImageIcon visualizeMenuIcon		= new ImageIcon("img/visualize.gif");
	ImageIcon visualizeButtonIcon		= new ImageIcon("img/carsim1.gif");
	ImageIcon visualizeButtonRolloverIcon	= new ImageIcon("img/carsim2.gif");
	ImageIcon visualizeButtonDownIcon	= new ImageIcon("img/carsim3.gif");

	ImageIcon backgroundIcon1		= new ImageIcon("img/background1.gif");
	ImageIcon backgroundIcon2		= new ImageIcon("img/background2.gif");
	ImageIcon backgroundIcon3		= new ImageIcon("img/background3.gif");
	ImageIcon backgroundIcon4		= new ImageIcon("img/background4.gif");

	ImageIcon demoButtonIcon		= new ImageIcon("img/demo1.gif");
	ImageIcon demoButtonRolloverIcon	= new ImageIcon("img/demo2.gif");
	ImageIcon demoButtonDownIcon		= new ImageIcon("img/demo3.gif");

	ImageIcon statusInfoIcon		= new ImageIcon("img/status_info.gif");
	ImageIcon statusOkIcon			= new ImageIcon("img/status_ok.gif");
	ImageIcon statusErrorIcon		= new ImageIcon("img/status_error.gif");
	ImageIcon statusEmptyIcon		= new ImageIcon("img/status_empty.gif");
	
	//############################################## Menubar
	JMenuBar menubar	= new JMenuBar();
	JMenu menuProgram	= new JMenu();
    	JMenu     menuProgramLanguage			= new JMenu();
	    	JMenuItem menuProgramLanguageEnglish	= new JRadioButtonMenuItem("English",languageEnglishIcon);
	    	JMenuItem menuProgramLanguageDeutsch	= new JRadioButtonMenuItem("Deutsch",languageDeutschIcon);
	    	JMenuItem menuProgramLanguageEspanol	= new JRadioButtonMenuItem("Espaol",languageEspanolIcon);
	    	JMenuItem menuProgramLanguageFrancais	= new JRadioButtonMenuItem("Franais",languageFrancaisIcon);
	    	JMenuItem menuProgramLanguageSvenska	= new JRadioButtonMenuItem("Svenska",languageSvenskaIcon);
	    	ButtonGroup languageButtonGroup		= new ButtonGroup();
    	JMenuItem menuProgramExit			= new JMenuItem();
	JMenu menuReport 	= new JMenu();
    	JMenuItem menuReportNew				= new JMenuItem(newButtonIcon);
    	JMenuItem menuReportSave			= new JMenuItem(saveButtonIcon);
    	JMenuItem menuReportDelete			= new JMenuItem();
    	JMenuItem menuReportGenerateXML			= new JMenuItem(generateXMLMenuIcon);
	JMenu menuXMLdoc	= new JMenu();
    	JMenuItem menuXMLdocNew				= new JMenuItem(newButtonIcon);
    	JMenuItem menuXMLdocSave			= new JMenuItem(saveButtonIcon);
    	JMenuItem menuXMLdocDelete			= new JMenuItem();
    	JMenuItem menuXMLdocValidate			= new JMenuItem(parseButtonIcon);
	JMenu menu3D		= new JMenu();
    	JMenuItem menu3DStart				= new JMenuItem(visualizeMenuIcon);
	JMenuItem menu3DPreferences			= new JMenuItem();
    	JMenuItem menu3DDemoA				= new JMenuItem();
    	JMenuItem menu3DDemoB				= new JMenuItem();
	JMenu menuHelp		= new JMenu();
    	JMenuItem menuHelpHelp				= new JMenuItem();
    	JMenuItem menuHelpAbout				= new JMenuItem();

	
	//############################################## Main Window
	
	Container MainWindowContainer;
	BorderLayout borderLayout0 	= new BorderLayout();
	
	//############################################## Report (panel1)
	
	JPanel panel1	= new JPanel();
	TitledBorder titledBorder1;
	CompoundBorder compoundBorder1;
	BorderLayout borderLayout1 	= new BorderLayout();
	
	JTextArea textArea1 		= new JTextArea();
	JScrollPane textArea1Scroll	= new JScrollPane(textArea1, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	
	JPanel panel1a			= new JPanel();
	BoxLayout boxLayout1 		= new BoxLayout(panel1a, BoxLayout.Y_AXIS);
	
	JPanel panel1aa			= new JPanel();
	BorderLayout borderLayout1aa	= new BorderLayout();
	
	JPanel panel1aaa		= new JPanel();
	BoxLayout boxLayout1aaa		= new BoxLayout(panel1aaa, BoxLayout.Y_AXIS);
	JButton newReportButton		= new JButton("",newButtonIcon);
	JButton saveReportButton	= new JButton("",saveButtonIcon);

	JList list1			= new JList();
 	JScrollPane scrollPane1		= new JScrollPane(list1, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	
	
	
	//############################################## XMLdoc (panel2)
	
	JPanel panel2			= new JPanel();
	TitledBorder titledBorder2;
	CompoundBorder compoundBorder2;
	BorderLayout borderLayout2 	= new BorderLayout();
	
	JTextArea textArea2 		= new JTextArea();
	JScrollPane textArea2Scroll	= new JScrollPane(textArea2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	
	JPanel panel2a			= new JPanel();
	BoxLayout boxLayout2a 		= new BoxLayout(panel2a, BoxLayout.Y_AXIS);
	
	JPanel panel2aa			= new JPanel();
	BorderLayout borderLayout2aa	= new BorderLayout();
	
	JPanel panel2aaa		= new JPanel();
	BorderLayout borderLayout2aaa	= new BorderLayout();
	JButton generateXMLButton	= new JButton("",generateXMLIcon);
	JPanel panel2aaaa		= new JPanel();
	BoxLayout boxLayout2aaaa	= new BoxLayout(panel2aaaa, BoxLayout.Y_AXIS);
	JButton newXMLdocButton		= new JButton("",newButtonIcon);
	JButton saveXMLdocButton	= new JButton("",saveButtonIcon);
	JButton parseXMLdocButton	= new JButton("",parseButtonIcon);
	
	JList list2			= new JList();
 	JScrollPane scrollPane2		= new JScrollPane(list2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	
	//############################################## 3D Visualization (panel3)
	
	JPanel panel3 			= new JPanel();
	TitledBorder titledBorder3;
	CompoundBorder compoundBorder3;
	BorderLayout borderLayout3	= new BorderLayout();
	JPanel panel3a 			= new JPanel();
	BoxLayout boxLayout3a 		= new BoxLayout(panel3a, BoxLayout.Y_AXIS);
	JPanel panel3b 			= new JPanel();
	BoxLayout boxLayout3b 		= new BoxLayout(panel3b, BoxLayout.Y_AXIS);
	
	JButton visualizeButton 	= new JButton("",visualizeButtonIcon);
	TitledBorder bgBorder;
	TitledBorder bgTxBorder;
	JPanel bgTxPanel		= new JPanel();
	BoxLayout bgTxBoxLayout		= new BoxLayout(bgTxPanel, BoxLayout.Y_AXIS);
	JButton backgroundButton 	= new JButton("",backgroundIcon1);
	JButton demoAButton 		= new JButton("Demo A",demoButtonIcon);
	JButton demoBButton 		= new JButton("Demo B",demoButtonIcon);
	
	//############################################## Statusbar
	
	JPanel statusPanel		= new JPanel();
	BorderLayout statusBorderLayout = new BorderLayout();
	JLabel statusLabel		= new JLabel("", JLabel.LEFT);
	JButton statusLED		= new JButton(statusEmptyIcon);
	
	//############################################## Constructor

	public MainWindow(MainWindow_Loading mw_l)
	{
		loading = mw_l;
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		loading.increaseProgressBar(); // #1
		
		try { jbInit(); }
		catch(Exception e) { e.printStackTrace(); }
		
	}

	//Initialisation of the components
	private void jbInit() throws Exception 
	{
		//##############################################  MainWindow
		
		this.setTitle("CarSim 1.1");
		this.setSize(new Dimension(800, 600));
		MainWindowContainer = this.getContentPane();
		MainWindowContainer.setLayout(borderLayout0);
		MainWindowContainer.setBackground(Color.white);
		MainWindowContainer.add(panel1,BorderLayout.WEST);
		MainWindowContainer.add(panel2,BorderLayout.CENTER);
		MainWindowContainer.add(panel3,BorderLayout.EAST);
		MainWindowContainer.add(statusPanel,BorderLayout.SOUTH);
		
		//##############################################  Report

		titledBorder1 	= new TitledBorder(null, "", TitledBorder.LEFT, TitledBorder.TOP, this.boldFont);
		compoundBorder1	= new CompoundBorder( titledBorder1, emptyBorder10);
		panel1.setBorder(compoundBorder1);
		panel1.setLayout(borderLayout1);
		panel1.setBackground(bgColor);
		
		textArea1.setLineWrap(true);
		textArea1.setWrapStyleWord(true);
		textArea1.setBackground(textareaColor);
		textArea1.setTabSize(4);
		panel1.add(textArea1Scroll, BorderLayout.CENTER);
		
		list1.setVisibleRowCount(4);
		panel1.add(panel1a, BorderLayout.SOUTH);
		
		panel1a.setLayout(boxLayout1);
		panel1a.setBackground(bgColor);
		panel1a.add(Box.createRigidArea(new Dimension(175,10)));
		
		panel1aa.setLayout(borderLayout1aa);
		panel1aa.setBackground(bgColor);
		
		panel1aaa.setLayout(boxLayout1aaa);
		panel1aaa.setBackground(bgColor);
		
		newReportButton.setFocusPainted(false);
		newReportButton.setContentAreaFilled(false);
		newReportButton.setMargin(insets3);
		panel1aaa.add(newReportButton);
		saveReportButton.setFocusPainted(false);
		saveReportButton.setContentAreaFilled(false);
		saveReportButton.setMargin(insets3);
		panel1aaa.add(saveReportButton);
		panel1aaa.add(Box.createRigidArea(square20));
		
		panel1aa.add(panel1aaa,BorderLayout.WEST);
		panel1aa.add(scrollPane1,BorderLayout.CENTER);
		panel1a.add(panel1aa);
		
		
		
		//##############################################  XML Document

		titledBorder2 	= new TitledBorder(null, "", TitledBorder.LEFT, TitledBorder.TOP, this.boldFont);
		compoundBorder2	= new CompoundBorder( titledBorder2, emptyBorder10);
		panel2.setBorder(compoundBorder2);
		panel2.setLayout(borderLayout2);
		panel2.setBackground(bgColor);
		
		textArea2.setLineWrap(false);
		textArea2.setBackground(textareaColor);
		textArea2.setTabSize(2);
		list2.setVisibleRowCount(4);
		panel2.add(textArea2Scroll, BorderLayout.CENTER);
		
		panel2a.setLayout(boxLayout2a);
		panel2a.setBackground(bgColor);
		panel2a.add(Box.createRigidArea(vpad10));
		
		panel2aa.setLayout(borderLayout2aa);
		panel2aa.setBackground(bgColor);
		
		panel2aaa.setBackground(bgColor);
		panel2aaa.setLayout(borderLayout2aaa);
		
		generateXMLButton.setPressedIcon(generateXMLPressedIcon);
		generateXMLButton.setRolloverIcon(generateXMLRolloverIcon);
		generateXMLButton.setRolloverEnabled(true);
		generateXMLButton.setFocusPainted(false);
		generateXMLButton.setContentAreaFilled(false);
		generateXMLButton.setMargin(new Insets(16,2,16,2));
		panel2aaa.add(generateXMLButton, BorderLayout.WEST);
		
		panel2aaaa.setBackground(bgColor);
		panel2aaaa.setLayout(boxLayout2aaaa);
		
		newXMLdocButton.setFocusPainted(false);
		newXMLdocButton.setContentAreaFilled(false);
		newXMLdocButton.setMargin(insets3);
		saveXMLdocButton.setFocusPainted(false);
		saveXMLdocButton.setContentAreaFilled(false);
		saveXMLdocButton.setMargin(insets3);
		parseXMLdocButton.setFocusPainted(false);
		parseXMLdocButton.setContentAreaFilled(false);
		parseXMLdocButton.setMargin(insets3);
		panel2aaaa.add(newXMLdocButton);
		panel2aaaa.add(saveXMLdocButton);
		panel2aaaa.add(parseXMLdocButton);
		panel2aaa.add(panel2aaaa, BorderLayout.CENTER);
		
		panel2aa.add(panel2aaa, BorderLayout.WEST);
		panel2aa.add(scrollPane2, BorderLayout.CENTER);
		
		panel2a.add(panel2aa);
		panel2.add(panel2a, BorderLayout.SOUTH);
		

		//##############################################  3D Visualization

		titledBorder3 	= new TitledBorder(null, "3D Visualization", TitledBorder.LEFT, TitledBorder.TOP, this.boldFont);
		compoundBorder3	= new CompoundBorder( titledBorder3, emptyBorder10);
		panel3.setBorder(compoundBorder3);
		panel3.setLayout(borderLayout3);
		panel3.setBackground(bgColor);
		
		
		
		panel3a.setBackground(bgColor);
		panel3a.setLayout(boxLayout3a);
		demoAButton.setPressedIcon(demoButtonDownIcon);
		demoAButton.setRolloverIcon(demoButtonRolloverIcon);
		demoAButton.setRolloverEnabled(true);
		demoAButton.setBorderPainted(false);
		demoAButton.setFocusPainted(false);
		demoAButton.setContentAreaFilled(false);
		panel3a.add(demoAButton);

		demoBButton.setPressedIcon(demoButtonDownIcon);
		demoBButton.setRolloverIcon(demoButtonRolloverIcon);
		demoBButton.setRolloverEnabled(true);
		demoBButton.setBorderPainted(false);
		demoBButton.setFocusPainted(false);
		demoBButton.setContentAreaFilled(false);
		panel3a.add(demoBButton);
		
		panel3b.setBackground(bgColor);
		panel3b.setLayout(boxLayout3b);
		bgBorder = new TitledBorder(null,"", TitledBorder.CENTER, TitledBorder.TOP, this.boldFont);
		bgTxBorder = new TitledBorder(bgBorder,"", TitledBorder.CENTER, TitledBorder.BOTTOM, this.boldFont);
		bgTxPanel.setBorder(bgTxBorder);
		backgroundButton.setRolloverEnabled(false);
		backgroundButton.setBorderPainted(false);
		backgroundButton.setFocusPainted(false);
		backgroundButton.setContentAreaFilled(false);
		backgroundButton.setMargin(insets0);
		bgTxPanel.add(backgroundButton);
		bgTxPanel.setLayout(bgTxBoxLayout);
		bgTxPanel.setBackground(bgColor);
		panel3b.add(bgTxPanel);
		
		visualizeButton.setPressedIcon(visualizeButtonDownIcon);
		visualizeButton.setRolloverIcon(visualizeButtonRolloverIcon);
		visualizeButton.setRolloverEnabled(true);
		visualizeButton.setBorderPainted(false);
		visualizeButton.setFocusPainted(false);
		visualizeButton.setContentAreaFilled(false);
		visualizeButton.setMargin(insets0);
		panel3b.add(visualizeButton);
		
		panel3.add(panel3a, BorderLayout.NORTH);
		panel3.add(panel3b, BorderLayout.SOUTH);
		
		
		
		//############################################## Statusbar
		
		statusPanel.setLayout(statusBorderLayout);
		statusLabel.setFont(statusFont);
		statusPanel.add(statusLabel, BorderLayout.CENTER);
		statusLED.setBorderPainted(false);
		statusLED.setFocusPainted(false);
		statusLED.setContentAreaFilled(false);
		statusLED.setMargin(insets0);
		statusPanel.add(statusLED, BorderLayout.WEST);
		
		//##############################################  Menu
		//structure
		
		menubar.add(menuProgram);
			menuProgram.add(menuProgramLanguage);
				menuProgramLanguage.add(menuProgramLanguageEnglish);
				menuProgramLanguage.add(menuProgramLanguageDeutsch);
				menuProgramLanguage.add(menuProgramLanguageEspanol);
				menuProgramLanguage.add(menuProgramLanguageFrancais);
				menuProgramLanguage.add(menuProgramLanguageSvenska);
		    	languageButtonGroup.add(menuProgramLanguageEnglish);
		    	languageButtonGroup.add(menuProgramLanguageDeutsch);
		    	languageButtonGroup.add(menuProgramLanguageEspanol);
		    	languageButtonGroup.add(menuProgramLanguageFrancais);
		    	languageButtonGroup.add(menuProgramLanguageSvenska);
			menuProgram.addSeparator();
    		menuProgram.add(menuProgramExit);
		menubar.add(menuReport);
			menuReport.add(menuReportNew);
			menuReport.add(menuReportSave);
			menuReport.add(menuReportDelete);
			menuReport.addSeparator();
    		menuReport.add(menuReportGenerateXML);
		menubar.add(menuXMLdoc);
			menuXMLdoc.add(menuXMLdocNew);
			menuXMLdoc.add(menuXMLdocSave);
			menuXMLdoc.add(menuXMLdocDelete);
			menuXMLdoc.addSeparator();
    		menuXMLdoc.add(menuXMLdocValidate);
		menubar.add(menu3D);
			menu3D.add(menu3DStart);
			menu3D.addSeparator();
			menu3D.add(menu3DDemoA);
			menu3D.add(menu3DDemoB);
			menu3D.addSeparator();
			menu3D.add(menu3DPreferences);
		menubar.add(menuHelp);
			menuHelp.add(menuHelpHelp);
			menuHelp.add(menuHelpAbout);

		/*
		// set the language
		switch(Messenger.properties.language)
		{
		case Messenger.properties.DEUTSCH:  Text.setTextes(Messenger.properties.DEUTSCH,  mw); break;
		case Messenger.properties.ESPANOL:  Text.setTextes(Messenger.properties.ESPANOL,  mw); break;
		case Messenger.properties.FRANCAIS: Text.setTextes(Messenger.properties.FRANCAIS, mw); break;
		case Messenger.properties.SVENSKA:  Text.setTextes(Messenger.properties.SVENSKA,  mw); break;
		default:                            Text.setTextes(Messenger.properties.ENGLISH,  mw); break;
		}
		*/
		
		/*
		// set the selected language menu item radio button
		switch(Messenger.properties.language)
		{
		case Messenger.properties.DEUTSCH:  menuProgramLanguageDeutsch.setSelected(true);
 break;
		case Messenger.properties.ESPANOL:  menuProgramLanguageEspanol.setSelected(true);
 break;
		case Messenger.properties.FRANCAIS: menuProgramLanguageFrancais.setSelected(true); break;
		case Messenger.properties.SVENSKA:  menuProgramLanguageSvenska.setSelected(true);
 break;
		default:                            menuProgramLanguageEnglish.setSelected(true);
 break;
		}
		*/
		
		// set the selected language menu item radio button
		switch(Messenger.properties.language)
		{
		case 1:  menuProgramLanguageDeutsch.setSelected(true);
 break;
		case 2:  menuProgramLanguageEspanol.setSelected(true);
 break;
		case 3:  menuProgramLanguageFrancais.setSelected(true); break;
		case 4:  menuProgramLanguageSvenska.setSelected(true);
 break;
		default:                            menuProgramLanguageEnglish.setSelected(true);
 break;
		}
		
		
		
		this.setJMenuBar(menubar);
		
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension MainWindowSize = this.getSize();
		if (MainWindowSize.height > screenSize.height) MainWindowSize.height = screenSize.height;
		if (MainWindowSize.width > screenSize.width) MainWindowSize.width = screenSize.width;
		this.setLocation((screenSize.width - MainWindowSize.width) / 2, (screenSize.height - MainWindowSize.height) / 2);
		
		
	}
	
	protected void processWindowEvent(WindowEvent e)
	{
		super.processWindowEvent(e);
		if(e.getID() == WindowEvent.WINDOW_CLOSING)
		{
			Messenger.saveProperties();
			System.exit(0);
		}
	}
}