// This is the window which appears when the MainWindow is loading.
// It contains a status bar that shows the actual loading state.

package  se.lth.cs.carsimgui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class MainWindow_Loading extends JFrame {

	private static final int MAX_PROGRESSBAR = 5;
	JPanel panel1			= new JPanel();
	JLabel imageControl1		= new JLabel();
	ImageIcon imageIcon;
		
	BorderLayout borderLayout1	= new BorderLayout();
	FlowLayout flowLayout2		= new FlowLayout();
	JProgressBar progressBar1	= new JProgressBar(0,MAX_PROGRESSBAR);
	
	public MainWindow_Loading()
	{
		super();
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try  {
			jbInit();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		imageControl1.setIcon(imageIcon);
		pack();
	}

	public void increaseProgressBar()
	{
		int value = progressBar1.getValue();
		if (value < progressBar1.getMaximum())
		{
			progressBar1.setValue(value+1);
		}
	}
	
	private void jbInit() throws Exception  {
		imageIcon = new ImageIcon("img/carsim.jpg");
		this.setTitle("Loading CarSim...");
		setResizable(false);
		panel1.setLayout(borderLayout1);
		panel1.setBackground(Color.black);
		imageControl1.setMaximumSize(new Dimension(486, 350));
		imageControl1.setMinimumSize(new Dimension(486, 350));
		imageControl1.setPreferredSize(new Dimension(486, 350));
		imageControl1.setHorizontalAlignment(SwingConstants.CENTER);
		imageControl1.setHorizontalTextPosition(SwingConstants.CENTER);
		panel1.add(imageControl1, BorderLayout.CENTER);
		panel1.add(progressBar1, BorderLayout.SOUTH);
		this.getContentPane().add(panel1, null);
	}
	
	protected void processWindowEvent(WindowEvent e) {
	}
}