// Class with static members for information exchange

//	Name: Messenger (class)
//	Author: Arjan Egges
//	Version: 1.0

package  se.lth.cs.carsimgui;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.InvalidClassException;

class Messenger {

   public static Properties properties;
   public static boolean toSystem = true;
   
   // Constructor
   Messenger() { }
   
   // Sets the properties
   static void setProperties(Properties p) {
      properties = p;
   }
   
   // loads the Properties object from file 
   static void loadProperties() {
      FileInputStream fis = null;
      ObjectInputStream in = null;
      try
      {
         fis = new FileInputStream("carsimdata/properties");
         in = new ObjectInputStream(fis);
         properties = (Properties)in.readObject();
         in.close();
      }
      catch(FileNotFoundException e)
      {
         properties = new Properties();
      }
      catch(InvalidClassException e)
      {
         properties = new Properties();
      }
      catch(Exception e)
      {
         System.out.println("Exception in Messenger.loadProperties(): "+e);
      }      
   }
   
   // saves the Properties object from file 
   static void saveProperties() {
      FileOutputStream fos = null;
      ObjectOutputStream out = null;
      try
      {
         fos = new FileOutputStream("carsimdata/properties");
         out = new ObjectOutputStream(fos);
         out.writeObject(properties);
         out.close();
      }
      catch(IOException e)
      {
         System.out.println("Exception in Messenger.saveProperties(): "+e);
      }
   }
   
   // Sends a message
   static void message(String text) {
      System.out.print(text);
   }
}
