// Class containing property variables for running the simulations

// 	Name: Properties (class)
//	Author: Arjan Egges
//	Version: 1.0

package  se.lth.cs.carsimgui;

import java.io.Serializable;

class Properties implements Serializable {

   public int language;
   public final static int ENGLISH		= 0;
   public final static int DEUTSCH		= 1;
   public final static int ESPANOL		= 2;
   public final static int FRANCAIS		= 3;
   public final static int SVENSKA		= 4;
	
   public boolean textureOn;
   public boolean createEnvironment;
   public int duration;
   
   // Accident planning properties
   public float initCircleRadius;
   public int trajectoryPrecision; 
   public float stopPerc;
   public float maxSearchRadius;
   
   // Constructor
   public Properties() {
      
      
      textureOn = true;
      createEnvironment = true;
      duration = 5;
      
      initCircleRadius = 2.0f;
      trajectoryPrecision = 10;
      stopPerc = 20.0f;
      maxSearchRadius = 8.0f;
   }
}