// JFrame for the properties window

//	Name: PropertyFrame (class)
//	Version: 1.0 by Arjan Egges
//	Version: 1.1 by Bastian Schulz
//	new: uses SWING and JSlider instead of textinput fields

package  se.lth.cs.carsimgui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


//import com.sun.j3d.utils.applet.MainFrame;
//import com.sun.j3d.utils.universe.*;
//import javax.media.j3d.*;


class PropertyFrame extends JFrame implements ActionListener, WindowListener
{
	MainWindowManager mwm;
	
	JSlider duration;
	JSlider initCRadius;
	JSlider tPrecision;
	JSlider sPerc;
   
	JButton okButton;
	JButton cancelButton;
   
	public PropertyFrame()
	{
	}

	public PropertyFrame(MainWindowManager mainWindowManager)
	{
		super(Text.at(14));
		mwm = mainWindowManager;
		addWindowListener(this);
		setResizable(false);
		
		JPanel contentPane = new JPanel();
		contentPane.setBackground(MainWindow.bgColor);
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
		contentPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	        
		JLabel durationLabel = new JLabel(Text.at(43), JLabel.CENTER);
		durationLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		duration = new JSlider(JSlider.HORIZONTAL,0, 20, Messenger.properties.duration);
		duration.setMajorTickSpacing(5);
		duration.setMinorTickSpacing(1);
		duration.setPaintTicks(true);
		duration.setPaintLabels(true);
		duration.setBackground(MainWindow.bgColor);
		
		JLabel initCRadiusLabel = new JLabel(Text.at(44), JLabel.CENTER);
		initCRadiusLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		initCRadius = new JSlider(JSlider.HORIZONTAL,0, 14, new Float(Messenger.properties.initCircleRadius).intValue());
		initCRadius.setMajorTickSpacing(2);
		initCRadius.setMinorTickSpacing(1);
		initCRadius.setPaintTicks(true);
		initCRadius.setPaintLabels(true);
		initCRadius.setBackground(MainWindow.bgColor);
		
		JLabel tPrecisionLabel = new JLabel(Text.at(45), JLabel.CENTER);
		tPrecisionLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		tPrecision = new JSlider(JSlider.HORIZONTAL,0, 100, Messenger.properties.trajectoryPrecision);
		tPrecision.setMajorTickSpacing(20);
		tPrecision.setMinorTickSpacing(5);
		tPrecision.setPaintTicks(true);
		tPrecision.setPaintLabels(true);
		tPrecision.setBackground(MainWindow.bgColor);
		
		JLabel sPercLabel = new JLabel(Text.at(46), JLabel.CENTER);
		sPercLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		sPerc = new JSlider(JSlider.HORIZONTAL,0, 50, new Float(Messenger.properties.stopPerc).intValue());
		sPerc.setMajorTickSpacing(10);
		sPerc.setMinorTickSpacing(2);
		sPerc.setPaintTicks(true);
		sPerc.setPaintLabels(true);
		sPerc.setBackground(MainWindow.bgColor);
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setBackground(MainWindow.bgColor);
		okButton = new JButton("OK");
		okButton.setFocusPainted(false);
		cancelButton = new JButton(Text.at(40));
		cancelButton.setFocusPainted(false);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		
		contentPane.add(durationLabel);
		contentPane.add(duration);
		contentPane.add(Box.createRigidArea(new Dimension(20,20)));
		contentPane.add(initCRadiusLabel);
		contentPane.add(initCRadius);
		contentPane.add(Box.createRigidArea(new Dimension(20,20)));
		contentPane.add(tPrecisionLabel);
		contentPane.add(tPrecision);
		contentPane.add(Box.createRigidArea(new Dimension(20,20)));
		contentPane.add(sPercLabel);
		contentPane.add(sPerc);
		contentPane.add(Box.createRigidArea(new Dimension(20,20)));
		contentPane.add(buttonPanel);
		setContentPane(contentPane);
	      
		okButton.addActionListener(this);
		cancelButton.addActionListener(this);
		
		this.pack();
		mwm.showWindowAtRightPlace(this);
	}
   
	private void setProperties()
	{
		
	}
   

	public void actionPerformed(ActionEvent event)
	{
		if (event.getSource() == okButton)
		{
			Messenger.properties.duration = duration.getValue();
			Messenger.properties.initCircleRadius = initCRadius.getValue();
			
			if (tPrecision.getValue()<1) { Messenger.properties.trajectoryPrecision = 1;}
			else { Messenger.properties.trajectoryPrecision = tPrecision.getValue(); }
			
			Messenger.properties.stopPerc = sPerc.getValue();
			
			dispose();
		}
		else if (event.getSource() == cancelButton)
		{
			dispose();
		}
    }
    
    public void windowClosing( WindowEvent event ) {
       dispose();
    }
   
   
    public void windowClosed( WindowEvent event ) {
    }
   
    public void windowDeiconified( WindowEvent event ) {}
   
    public void windowIconified( WindowEvent event ) {}
   
   
public void windowDeactivated( WindowEvent event ) {}
   
    public void windowActivated( WindowEvent event ) {}
   
    public void windowOpened( WindowEvent event ) {}
}