// Applet that runs a simulation, given an AccidentUniverse object.

// 	Name: Simulation (class)
//	Author: Arjan Egges
//	Version: 1.0


package  se.lth.cs.carsimgui;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.sun.j3d.utils.applet.MainFrame;



class Simulation extends Frame implements ActionListener, WindowListener {
    // Window Components
    Panel controlPanel;
    Panel canvasPanel;
    Button playpauseButton;
    Button stopButton;
                   
    // Variables for handling dynamics
    boolean playing = false;
    boolean playFromBegin = true;
    
    AccidentUniverse au;
    
  public Simulation(AccidentUniverse a){
  
      super("Simulation [idle]");
      addWindowListener(this);
      setResizable(false);
      
      au = a;
      
      // Create the geometry.   
      au.createAll();
            
      // Create the canvas and the control panel
      this.setLayout(new FlowLayout()); 
      this.setSize(600,650);  
      canvasPanel = new Panel();
      controlPanel = new Panel();
      createControlPanel(controlPanel); 
      this.add(controlPanel);
      canvasPanel.add(au.getCanvas());
      this.add(canvasPanel);
      this.show();
   }
    
    private void createControlPanel(Panel p) {
       stopButton = new Button("Stop");
       playpauseButton = new Button("Play");
              
       p.add(stopButton);
       p.add(playpauseButton);
               
       stopButton.addActionListener (this);
       playpauseButton.addActionListener (this);
    }    

    // Button event handling
    public void actionPerformed (ActionEvent event) {
      if (event.getSource() == playpauseButton) {
          if (!playing) {
            setTitle("Simulation [running]");
            playing = true;
            playpauseButton.setLabel("Pause");
            if (playFromBegin)
               au.play();
            else
               au.resume();
          } else {
             setTitle("Simulation [paused]");
             au.pause();
             playFromBegin = false;
             playing = false;
             playpauseButton.setLabel("Play");
          }
      } else if (event.getSource() == stopButton) {
         setTitle("Simulation [idle]");
         au.stop();
         playing = false;
         playFromBegin = true;
         playpauseButton.setLabel("Play");
      }  
    }   
    
    // Additional methods for  window event handling.
    
    public void windowClosing( WindowEvent event ) {
       Messenger.message("End of simulation...\n");
       dispose();
    }
   
    public void windowClosed( WindowEvent event ) {
    }
   
    public void windowDeiconified( WindowEvent event ) {}
   
    public void windowIconified( WindowEvent event ) {}
   
   
public void windowDeactivated( WindowEvent event ) {}
   
    public void windowActivated( WindowEvent event ) {}
   
    public void windowOpened( WindowEvent event ) {}
}


   