// This class calculates the collision coordinates of an accident with
// a static object.

// 	Name: StaticAccidentCalculator (class)
//	Author: Arjan Egges
//	Version: 1.0

package  se.lth.cs.carsimgui;

class StaticAccidentCalculator {

   // Startposition of the actor vehicle
   public float xPos = 0.0f;
   public float yPos = 0.0f;
   
   // The calculated position
   public float endPosX = 0.0f;
   public float endPosY = 0.0f;
   
   // The vehicle part (frontal, leftside etc.)
   public int vehiclepart = Constant.UNKNOWN_PART;

   // Private member
   private AccidentObject target;
   
   // Constructor
   public StaticAccidentCalculator(AccidentObject t) {
      target = t;
   }
   
   // Calculates the collision coordinates
   public void calculate() {
      // This consists of calling the CollisionPlanner!

      Event vEvent = new Event();
      vEvent.startPosX = xPos;
      vEvent.startPosY = yPos;
      CollisionPlanner vPlanner = new CollisionPlanner(vEvent);
      vPlanner.collX = target.getXPos();
      vPlanner.collY = target.getYPos();
      vPlanner.vehiclepart = vehiclepart;
      vPlanner.vehicleLength = target.getCollisionRadius();
      vPlanner.vehicleWidth = target.getCollisionRadius();
      
      vPlanner.plan();

      // Set the right end coordinates
      endPosX = vEvent.endPosX;
      endPosY = vEvent.endPosY;      
   }
}