// Class for reading a VRML file.

// 	Name: VrmlGroupLoader (class)
//	Author: Arjan Egges
//	Version: 1.0


package  se.lth.cs.carsimgui;

import com.sun.j3d.utils.image.*;
import java.util.Enumeration;
import javax.media.j3d.*;
import com.sun.j3d.loaders.vrml97.VrmlLoader;
import com.sun.j3d.loaders.Scene;

class VrmlGroupLoader {

   // private members
   private String filename;
   private VrmlLoader loader;
   private TransformGroup objectGroup;

   // Constructor
   public VrmlGroupLoader(String fn) {
      filename = fn;
      loader = new VrmlLoader();
      
      // Try to load the Vrml file
            Scene scene;
      Messenger.message("Attempt to load vrml file <"+filename+">...");
      try {
         scene = loader.load(filename);
      } catch (Exception e) {
         Messenger.message("failed.\n");
         return;
      }
      
      BranchGroup bGroup = scene.getSceneGroup();
      objectGroup = new TransformGroup();
      int numChilds = bGroup.numChildren();
      for (int i = numChilds-1; i>=0; i--) {
         Node n = bGroup.getChild(i);
         bGroup.removeChild(i);
         objectGroup.addChild(n);
      }
      Messenger.message("succeeded.\n");
   }

   // Returns the TransformGroup containing the VRML information
   public TransformGroup getTransformGroup() {
      return objectGroup;
   }
}